unit ImgFilter;

interface

uses NLibW;

type
  TImgInfo = record
    Width: Cardinal;
    Height: Cardinal;
    Components: Cardinal;
    Bpp: Cardinal;
    FormatName: string;
    Comment: string;
  end;

  TImgFilterMemAlloc = function (Size: Cardinal): Pointer;

  TImgFilterClass = class of TImgFilter;
  TImgFilter = class(TObject)
  protected
    FName: string;
    Alloc: TImgFilterMemAlloc;
  public
    constructor Create(Alloc: TImgFilterMemAlloc); overload; virtual;
    function Test(Buf: PChar; BufSize: Cardinal): Boolean; virtual; abstract;
    procedure Decode(InBuf: PChar; InBufSize: Cardinal; var OutBuf: PChar;
      var OutBufSize: Cardinal; var ImgInfo: TImgInfo); virtual; abstract;
    property Name: string read FName;
  end;

  EImgFilterError = class(Exception);

implementation

constructor TImgFilter.Create(Alloc: TImgFilterMemAlloc);
begin
  Self.Alloc := Alloc;
end;

end.
