unit NArgParserW;

interface

uses NTypes, NLibW;

type
  TArgParser = object
  private
    ArgInd: Integer;
    FArgs: TWideStringArray;
    Opt: PWideChar;
  public
    function Args: TWideStringArray;
    function GetArg: WideString;
    function GetOpt(var Opt_: WideChar): Boolean;
  end;

function ArgParser(): TArgParser; overload;
function ArgParser(const Args: array of WideString): TArgParser; overload;

implementation

uses NSysW;

function ArgParser(): TArgParser;
begin
  Result.FArgs := Argv;
  Result.ArgInd := 1;
end;

function ArgParser(const Args: array of WideString): TArgParser;
var
  i: Integer;
begin
  SetLength(Result.FArgs, Length(Args));
  for i := 0 to High(Result.FArgs) do 
    Result.FArgs[i] := Args[i];
end;

function TArgParser.Args: TWideStringArray;
begin
  Result := SliceArrayW(FArgs, ArgInd);
end;

function TArgParser.GetOpt(var Opt_: WideChar): Boolean;
begin
  if Opt <> nil then
    Inc(Opt);

  if (Opt = nil) or (Opt^ = #0) then
  begin
    Result := False;
    if ArgInd = Length(FArgs) then
      Exit;
    Opt := PWideChar(FArgs[ArgInd]);
    if Opt = '--' then
    begin
      Inc(ArgInd);
      Exit;
    end;
    if (Opt^ = '-') and (Length(Opt) > 1) then
      Inc(Opt)
    else
      Exit;
    Inc(ArgInd);
  end;
  Opt_ := Opt^;
  Result := Opt_ <> #0;
end;

function TArgParser.GetArg: WideString;
begin
  Inc(Opt);
  if Opt^ = #0 then
  begin
    if ArgInd < Length(FArgs) then
    begin
      Result := FArgs[ArgInd];
      Inc(ArgInd); 
    end else
      Result := '';
  end else
    Result := Opt;
  Opt := nil;
end;

end.
